/**
 * berschrift:		RentalCarStock
 * Beschreibung:	Exercise course module 7.
 *						This interface models a list with one actual element.
 *						This element is the default operator for the methods
 *						described below
 * Copyright:		Copyright (c) 2001
 * Organisation:	DVT
 * @author 			Shahriar Fakher, Thomas H. A. Dammann
 * @version 		$Revision: 1.3 $ --- $Date: 2001/09/26 16:28:24 $
 */

public interface List {

	/** returns the first element of the list. This element becomes the
	 *		actual element. If the list is empty (<code>isEmpty ==
	 *		true</code>) then <code>head()</code> returns the
	 *		<code>null</code> object.  
	 *
	 *		@return the first <code>Element</code> of the list if the list
	 *			isn't empty else the <code>null</code> object.
	 */

	 public Element head();

	/** returns the element after the actual. This element becomes the
	 *		actual element. If the acual element before the execution was
	 *		the last one then <code>null</code> is returned.
	 *
	 *		@return the next <code>Element</code> after the actual or
	 *			<code>null</code>.
	 */

	 public Element nextElem();

	/** returns the actual element of the list. This element remains the
	 *		actual element. <code>null</code> is returned when the list is
	 *		empty.
	 *
	 *		@return the actual <code>Element</code> of the list or
	 *			<code>null</code>.
	 */

	 public Element get();

	/** canges the actual element of the list to <code>elem</code>. This
	 * 		element remains the actual element. 
	 * 		
	 *
	 * 		@param  elem the <code>Element</code> that should be the new one
	 * 			at the actual position.
	 *		
	 */

	 public void change(Element elem);
	
	/** inserts the element <code>toBeInserted</code> at the end of the
	 * 		list. This element becomes the actual element. 
	 *
	 * 		@param  toBeInserted the <code>Element</code> that should be
	 * 			inserted at the end of the list.
	 */

	 public void insert(Element toBeInserted);

	/** returns <code>true</code> if the list is empty.
	 * 
	 * 		@return wether the list is empty
	 *
	 * 	*/

	 public boolean isEmpty();


	/** deletes the element <code>toBeDeleted</code> if one
	 * 		<code>Element elem</code> with
	 * 		<code>elem.equals(toBeDeleted)</code> is found in the list. The
	 * 		actual element becomes the elment after the deleted element. If
	 * 		the deleted element was at the end, the actual elment is the
	 * 		last one. If <code>toBeDeleted</code> cannot be found in the
	 * 		list then nothing is done, i. e. especially that the actual
	 * 		element is as before the method call.
	 *
	 * 		@param  toBeDeleted the <code>Element</code> that should be
	 * 		deleted.
	 */

	 public void delete(Element toBeDeleted);

	/** delivers the element <code>elem</code> that satisfies
	 * 		<code>elem.equals(toBeDeleted)</code>. If there isn't such an
	 * 		element then <code>null</code> is returned.
	 *
	 * 		@param  toBeDeleted the <code>Element</code> that should be
	 * 			deleted.
	 * 		@return the found element or <code>null.</code>
	 */

	 public Element find(Element elem);
}
